# Ruby executable creator
# By King Kadelfek

# You need Ruby 1.8.6 and Exerb 5.2.0 (Exerb 4.2 works too)

# Example :
# file_exe = Compilateur::run(["-e", __FILE__])


class Compilateur

  F_COMPIL = "compil"


  def self.compil?
    return defined?(Exerb) != nil
  end

  def self.is_exe?
    return Module.constants.include?("ExerbRuntime")
  end

  def self.go(path)
    if compil? == false and is_exe? == false
      self::run(["-e", path])
    end
  end


  def self.run(argv)
    

    syntaxe = "main.rb \"[-e, -r]\" \"chemin_absolu_fichier.rb\""
    erreur_syntaxe = "Syntax command is #{syntaxe}"

  
    if argv.size > 2 or argv.size == 0
      raise(erreur_syntaxe)
    end

    mode = 0

    if argv.size == 2
      mode = argv[0]
      if /^-e$|^-r$/i.match(mode).nil?
        raise(erreur_syntaxe)
      end
      if /^-e$/i.match(mode).nil? == false
        # Compilation Exerb
        mode = 0
      else
        # Compilation Rubyscript2exe
        mode = 1
      end
      f_rb = argv[1]
    else
      f_rb = argv[0]
    end


    if File.exists?(f_rb) == false
      raise("le fichier #{f_rb} n'existe pas")
      gets
    end
  
    f_rb = f_rb.gsub("\\", "/")
  
    if mode == 0
      return compiler_exerb(f_rb)
    else
      return compiler_rubyscript2exe(f_rb)
    end

  end




  def self.compiler_exerb(f_rb)

    puts "lancement de la compilation Exerb"

    f_exy = f_rb.sub(/rb$/i, "exy")

    #chemin = /(.*)[\/].*$/.match(f_rb)[1]+"/"
    chemin = f_rb.dirname

    #system("c:/ruby/bin/ruby -r exerb/mkexy \"#{f_rb}\"")
    
    puts "Modification du fichier exy"
    
    #contenu = DA::file_read(f_exy, "rb")
    #contenu.gsub!(chemin, "")
    #DA::file_write(f_exy, contenu, "wb")

    old_dir = Dir.pwd
    Dir.chdir("c:/ruby/bin")
    puts "Compilation exerb..."


    system("exerb \"#{f_exy}\"")

    Dir.chdir(old_dir)

    puts "Compilation Exerb terminee"
    
    return File.forcer_extension(f_rb, "exe")
  end






  def self.compiler_rubyscript2exe(f_rb)

    puts "lancement de la compilation Rubyscript2exe"

    raise("non encore developpee")

  end


end