#---------------------------------------------------------------------------------------------------------------
# ? Script Creer_PNG, cr par MGCaladtogel pour la communaut rpgmakerxp-factory.net
#---------------------------------------------------------------------------------------------------------------
#==============================================================================
#  Bitmap
#------------------------------------------------------------------------------
#  Ajoute une mthode pour crer un fichier image PNG (Portable Network Graphic)
#   partir d'une instance de la classe Bitmap.
#  La library "zlib.dll" est utilise pour la compression des donnes et la
#  cration des blocs de vrification CRC.
#==============================================================================

class Bitmap
  #--------------------------------------------------------------------------
  # ? mthode d'appel pour crer un fichier PNG
  #     chemin : chemin + nom du fichier  crer
  #     exemple : crer_png("Data/Characters/MonPersonnage.png")
  #--------------------------------------------------------------------------
  def creer_png(chemin)
    flux = creer_flux_donnees
    flux_compr = compresser_flux(flux)
    creer_fichier(chemin, flux_compr)
  end
  #--------------------------------------------------------------------------
  # ? mthode interne : cre le flux de donnes  compresser  partir
  #     des informations RVB+Alpha des pixels
  #--------------------------------------------------------------------------
  def creer_flux_donnees
    @old_time =Time.new
    flux = "0"
    for i in 0..self.height-1
      for j in 0..self.width-1
        couleur = get_pixel(j, i)
        flux.concat((couleur.red).to_i)
        flux.concat((couleur.green).to_i)
        flux.concat((couleur.blue).to_i)
        flux.concat((couleur.alpha).to_i)
      end
      flux.concat(0)
              new_time = Time.new
        if new_time-@old_time > 3
          @old_time = new_time
          ##@window_rate.contents.clear
          #@window_rate.contents.draw_text(0, 0, 200, 32, avancement(0))
          Graphics.update
        end
    end
    return flux
  end
  #--------------------------------------------------------------------------
  # ? mthode interne : utilisation de la library "zlib.dll" pour effectuer
  #     une compresion des donnes
  #--------------------------------------------------------------------------
  def compresser_flux(flux)
    flux_compr = Zlib::Deflate.deflate(flux, Zlib::DEFAULT_COMPRESSION)
    return flux_compr
  end
  #--------------------------------------------------------------------------
  # ? mthode interne : criture du fichier PNG
  #--------------------------------------------------------------------------
  def creer_fichier(chemin, flux_compr)
    ### cration et ouverture d'un fichier
    fichier = File.open(chemin, "w+")
    ### signature de fichier PNG
    sign = [137, 80, 78, 71, 13]
    signature = ""
    for element in sign
      signature.concat(element)
    end
    fichier.write(signature)
    fichier.binmode
    fichier.puts()
    fichier.binmode
    fichier.write("".concat(0x1A))
    fichier.binmode
    fichier.puts()
    fichier.binmode
    ### en-tte de l'image IHDR
    ## longueur et type
    long = [0, 0, 0, 13]
    longueur = ""
    for element in long
      longueur.concat(element)
    end
    fichier.write(longueur)
    fichier.write("IHDR")
    ## donnes IHDR
    # largeur de l'image
    larg = self.width
    larg = larg.to_s(2)
    while larg.length < 32
      larg = "0" + larg
    end
    largeur = ""
    for k in 0..3
      largeur.concat((larg[8*k, 8]).to_i(2))
    end
    # hauteur de l'image
    haut = self.height
    haut = haut.to_s(2)
    while haut.length < 32
      haut = "0" + haut
    end
    hauteur = ""
    for k in 0..3
      hauteur.concat((haut[8*k, 8]).to_i(2))
    end
    # profondeur de bit (ici 8 bits par couleur R, V, B)
    prof = "".concat(8)
    # type de couleur (ici 6 : RVB + Alpha)
    coul = "".concat(6)
    # mthode de compression (ici 0 : mthode "deflate")
    compr = "".concat(0)
    # filtre (ici 0 : pas de filtre)
    filt = "".concat(0)
    # entrelacement (ici 0 : pas d'entrelacement)
    entr = "".concat(0)
    data = largeur + hauteur + prof + coul + compr + filt + entr
    fichier.write(data)
    ## CRC (Cyclic Redundancy Check)
    crc = Zlib.crc32("IHDR" + data)
    crc = crc.to_s(2)
    while crc.length < 32
      crc = "0" + crc
    end
    crcIdat = ""
    for k in 0..3
      crcIdat.concat((crc[8*k, 8]).to_i(2))
    end
    fichier.write(crcIdat)
    ### bloc d'informations sRGB
    ## longueur et type
    long = [0, 0, 0, 1]
    longueur = ""
    for element in long
      longueur.concat(element)
    end
    fichier.write(longueur)
    fichier.write("sRGB")
    ## donnes sRGB
    data = "".concat(0)
    fichier.write(data)
    ## CRC
    crc = Zlib.crc32("sRGB" + data)
    crc = crc.to_s(2)
    while crc.length < 32
      crc = "0" + crc
    end
    crcsRGB = ""
    for k in 0..3
      crcsRGB.concat((crc[8*k, 8]).to_i(2))
    end
    fichier.write(crcsRGB)
    ### bloc d'informations gAMA
    ## longueur et type
    long = [0, 0, 0, 4]
    longueur = ""
    for element in long
      longueur.concat(element)
    end
    fichier.write(longueur)
    fichier.write("gAMA")
    ## donnes gAMA
    dat = "0000b18f"
    data= ""
    for k in 0..3
      data.concat(dat[2*k, 2].to_i(16))
    end
    fichier.write(data)
    ## CRC
    crc = Zlib.crc32("gAMA" + data)
    crc = crc.to_s(2)
    while crc.length < 32
      crc = "0" + crc
    end
    crcgAMA = ""
    for k in 0..3
      crcgAMA.concat((crc[8*k, 8]).to_i(2))
    end
    fichier.write(crcgAMA)
    ### bloc d'informations cHRM
    ## longueur et type
    long = [0, 0, 0, 32]
    longueur = ""
    for element in long
      longueur.concat(element)
    end
    fichier.write(longueur)
    fichier.write("cHRM")
    ## donnes cHRM
    dat0 = "7a268084fa0080e87530ea603a981770"
    dat = ""
    for k in 0..7
      dat = dat + "0000" + dat0[4*k, 4]
    end
    data= ""
    for k in 0..31
      data.concat(dat[2*k, 2].to_i(16))
    end
    fichier.write(data)
    ## CRC
    crc = Zlib.crc32("cHRM" + data)
    crc = crc.to_s(2)
    while crc.length < 32
      crc = "0" + crc
    end
    crccHRM = ""
    for k in 0..3
      crccHRM.concat((crc[8*k, 8]).to_i(2))
    end
    fichier.write(crccHRM)
    ### donnes de l'image IDAT
    ## longueur et type
    long = flux_compr.length
    long = long.to_s(2)
    while long.length < 32
      long = "0" + long
    end
    longueur = ""
    for k in 0..3
      longueur.concat((long[8*k, 8]).to_i(2))
    end
    fichier.write(longueur)
    fichier.write("IDAT")
    ## donnes compresses
    fichier.write(flux_compr)
    ## CRC
    crc = Zlib.crc32("IDAT" + flux_compr)
    crc = crc.to_s(2)
    while crc.length < 32
      crc = "0" + crc
    end
    crcIend = ""
    for k in 0..3
      crcIend.concat((crc[8*k, 8]).to_i(2))
    end
    fichier.write(crcIend)
    ### fin du fichier IEND
    ## longueur et type
    long = [0, 0, 0, 0]
    longueur = ""
    for element in long
      longueur.concat(element)
    end
    fichier.write(longueur)
    fichier.write("IEND")
    ## CRC
    crc = Zlib.crc32("IEND")
    crc = crc.to_s(2)
    while crc.length < 32
      crc = "0" + crc
    end
    crcIend = ""
    for k in 0..3
      crcIend.concat((crc[8*k, 8]).to_i(2))
    end
    fichier.write(crcIend)
    ### fermeture du fichier
    fichier.close
  end
end