


class Bitmap


  def ram
    return self.width*self.height*4.8
  end

  def blt_src(x_o, y_o, origin)
    self.blt(0, 0, origin, Rect.new(x_o, y_o, self.width, self.height))
  end

  def blt_dest(x_d, y_d, dest)
    dest.blt(x_d, y_d, self, self.rect)
  end

  def blt_simple(orig)
    self.blt(0, 0, orig, orig.rect)
  end

  def dimensions
    return self.width, self.height
  end

  def same_size
    return Bitmap.new(self.width, self.height)
  end



  def self.test_font(font)
    bmp = Bitmap.new(1, 1)
    bmp.font = font
    return bmp
  end

  def text_width_max(text)
    lst = text.split("\n")
    w_max = -1
    for txt in lst
      w = (self.text_size(txt)).width
      if w > w_max
        w_max = w
      end
    end
    return w_max
  end

  def text_height_max(text)
    rect = (self.text_size(text))
    return rect.height
  end


  def fill(color)
    return self.fill_rect(self.rect, color)
  end


  # Auteur : internet
  def draw_line(start_x, start_y, end_x, end_y, start_color, width = 1, end_color = start_color)

    distance = (start_x - end_x).abs + (start_y - end_y).abs
    
    if end_color == start_color
      for i in 1..distance
        x = (start_x + 1.0 * (end_x - start_x) * i / distance).to_i
        y = (start_y + 1.0 * (end_y - start_y) * i / distance).to_i
        self.fill_rect(x, y, width, width, start_color)
      end
    else
      for i in 1..distance
        x = (start_x + 1.0 * (end_x - start_x) * i / distance).to_i
        y = (start_y + 1.0 * (end_y - start_y) * i / distance).to_i
        r = start_color.red * (distance-i)/distance + end_color.red * i/distance
        g = start_color.green * (distance-i)/distance + end_color.green * i/distance
        b = start_color.blue * (distance-i)/distance + end_color.blue * i/distance
        a = start_color.alpha * (distance-i)/distance + end_color.alpha * i/distance
        self.fill_rect(x, y, width, width, Color.new(r, g, b, a))
      end
    end

  end


  def font_copy(new_font)
    self.font.size = new_font.size
    self.font.name = new_font.name
    self.font.color = new_font.color
  end

end