

# Transforme une documentation Rdoc en documentation RMXP
#
# Cette documentation :
#  # Exemple de ligne normale
#  # Exemple de ligne normale
#  #  Exemple de code
#  #  Exemple de code
#  # Exemple de ligne normale
#  def my_function
#
# Devient ceci :
#  #=============================================
#  # * my_function
#  # Exemple de ligne normale
#  # Exemple de ligne normale
#  # -----
#  #  Exemple de code
#  #  Exemple de code
#  # -----
#  # Exemple de ligne normale
#  #=============================================
#  def my_function
def doc_rmxp(cc="")

  reg = /((?:[ \t]*# *(?:[\S][^\n]*\n| *\n))+)[ \t]*def ([^(\n]*)/m
  reg_ex = /([ \t]*#  [\S].*?\n)[ \t]*?([ \t]*# (?! )|$)/m
  reg_esp = /^( *)#/

  all_lignes = cc.scan(reg)

  for m in all_lignes

    lignes = m[0]
    nom = m[1]

    # On rcupre le nombre d'espaces devant la premire ligne de
    # commentaires
    n = reg_esp.match(lignes)
    esp = n[1]

    tirets = esp+"# "+"-"*5+"\n"

    all_exemples = lignes.scan(reg_ex)
    lignes2 = lignes.clone
    for o in all_exemples
      lignes2.sub!(o[0], tirets+"#{o[0]}"+tirets)
    end

    bloc = esp+"#"+"="*45+"\n"
    cc.sub!(lignes, "#{bloc}#{esp}# * #{nom}\n#{lignes2}#{bloc}")
  end

end