#==============================================================================
# ** Method & Class Library
#------------------------------------------------------------------------------
# Build Date  - 09-17-2006
# Version 1.0 - 09-17-2006 - Trickster
# Version 1.1 - 10-03-2006 - Trickster
# Version 1.2 - 11-01-2006 - Trickster & Selwyn
# Version 1.3 - 11-10-2006 - Trickster
# Version 1.4 - 12-01-2006 - Trickster
# Version 1.5 - 01-01-2007 - Trickster, Yeyinde & Lobosque
# Version 2.0 - 04-26-2007 - MACL Authors
# Version 2.1 - 07-22-2007 - MACL Authors
# Version 2.2 - 11-20-2007 - MACL Authors & SephirothSpawn
# Version 2.3 - 06-19-2008 - SephirothSpawn & Zeriab
#==============================================================================

#==============================================================================
# ** Method & Class Library Settings
#------------------------------------------------------------------------------
# ** General MACL Settings
#
#   * Pose Names for Charactersets
#    - Poses = ['down', 'left', 'right', 'up']
#   * Number of Frames Per Pose for charactersets
#    - Frames = 4
#   * Real Elements
#    - Real_Elements = 1, 2, 3, 4, 5, 6, 7, 8
#
# ** Action Test Setup
#
#   * Attack Using
#     - Set this to the basic ids that perform an attack effect
#   * Skill Using
#     - Set this to the kinds that perform an skill effect
#   * Defend Using
#     - Set this to the basic ids that perform an defend effect
#   * Item Using
#     - Set this to the kinds that perform a item using effect
#   * Escape Using
#     - Set this to the basic ids that perform an escape effect
#   * Wait Using
#     - Set this to the basic ids that perform a wait effect
#
# ** Font
#
#   * Default Text Underline Setting
#    - Default_Underline = true or false
#   * Default Text Underline Full Setting
#    - Default_Underline_Full = true or false
#   * Default Text Strikethrough Setting
#    - Default_Strikethrough = true or false
#   * Default Text Stikethrough Full Setting
#    - Default_Strikethrough_Full = true or false
#   * Default Text Shadow Setting
#    - Default_Shadow = true or false
#   * Default Text Shadow Color Setting
#    - Default_Shadow_Color = Color.new(0, 0, 0, 100)
#   * Default Text Outline Setting
#    - Default_Outline = true or false
#   * Default Text Outline Color Setting
#    - Default_Outline_Color = Color.new(0, 0, 0, 100)
#   * Default Text Vertical Gradient Setting
#    - Default_Vert_Grad = true or false
#   * Default Text Horizontal Gradient Setting
#    - Default_Horiz_Grad = true or false
#   * Default Text Gradient Start Color Setting
#    - Default_Grad_S_Color = Color.new(0, 0, 0, 100)
#   * Default Text Gradient End Color Setting
#    - Default_Grad_E_Color = Color.new(0, 0, 0, 100)
#   * Default Font Addon Order (For multi-add settings)
#    - Font_Addon_Order = [:method_name, :method_name, ...]
#
# ** State Icon Settings
#
#   * Normal Icon Filename
#    - Normal_Icon = 'filename'
#   * State Specific Icons
#    - Icon_Name = {state_id => 'filename', ...}
#
# ** Bitmap Draw Settings
#
#   * Bitmap.draw_equip settings (Icon Type Settings When Item Not Equipped)
#    - Draw_Equipment_Icon_Settings = {type_id => icon_name, ...}
#   * Bitmap.draw_blur settings
#    - Blur_Settings = {setting_key => setting, ...}
#    Setting Keys
#     'offset'  - Pixels to be offseted when bluring
#     'spacing' - Number of times to offset blur
#     'opacity' - Max Opacity of blur
#   * Bitmap.draw_anim_sprite settings
#    - Anim_Sprite_Settings = {setting_key => setting, ...}
#    Settings
#     'f' - Frame count reset
#     'w' - Number of frames wide in sprite set
#     'h' - Height of frames wide in sprite set
#==============================================================================

module MACL
  #-------------------------------------------------------------------------
  # * Author Settings (DO NOT TOUCH)
  #-------------------------------------------------------------------------
  Version   = 2.3
  Loaded = []
end
