#============================================================================== 
# ** Ruby.Range
#------------------------------------------------------------------------------
# Description:
# ------------
# Methods created for finding and returning objects inside of an array.
#  
# Method List:
# ------------
# random
# <=>
#==============================================================================

MACL::Loaded << 'Ruby.Range'

#============================================================================== 
# ** Range     
#==============================================================================

class Range
  #--------------------------------------------------------------------------
  # * Include Comparable
  #--------------------------------------------------------------------------
  include(Comparable)
  #--------------------------------------------------------------------------
  # * Name      : Random
  #   Info      : Returns random object in array
  #   Author    : SephirothSpawn
  #   Call Info : Nil
  #--------------------------------------------------------------------------
  def random
    return self.to_a.random
  end
  #--------------------------------------------------------------------------
  # * Name      : <=>
  #   Info      : Compares ranges
  #   Author    : hanmac
  #   Call Info : One Argument, Other range
  #--------------------------------------------------------------------------
  def <=>(other)
    temp = first <=> other.first
    temp = last <=> other.last if temp == 0
    return temp
  end
end