# coding: iso-8859-1

# Classe charge de lister et de faire un require des fichiers prsents
# dans le projet
#
# Author : King Kadelfek
#
# v1.3




# Pour pouvoir utiliser la couche d'accs au disque et lister les dossiers
require File.join(File.dirname(__FILE__), "Ruby/Array.rb")
require File.join(File.dirname(__FILE__), "Ruby/Dir.rb")
require File.join(File.dirname(__FILE__), "Data_Access/DA.rb")
require File.join(File.dirname(__FILE__), "Data_Access/Archive.rb")


F_REQUIRE = "require.txt"

def verify_require_avoid
  if $require_avoid_reg == nil
    if $RMXP == true
      $require_avoid_reg = /require/i
    else
      $require_avoid_reg = /require|RMXP/i
    end

  end
  txt = $require_avoid_reg.to_s
  if (/[:\|]require[\|\)]/ === txt) == false
    txt.sub!(/\)$/, "|require)")
    $require_avoid_reg = Regexp.new(txt)
  end
end
verify_require_avoid


def getz
  0/0 if gets.chop != ""
end

if defined?(exe?) == nil
  def exe?
    return false
  end
end

def raisee(message, *params)
  mess = ""
  mess = $!.message+"\n" if $! != nil
  raise(mess+sprintf(message, *params))
end

def pause(temps=0)
  if temps == 0
    puts "Appuyez sur Entree"
    gets
  else
    puts "Pause : #{temps} seconds"
    sleep temps
  end
end


def require2(file)
  lib = File.join(File.dirname(__FILE__), file)
  require lib
end


def listerc_all
  lister_rb(File.dirname(__FILE__))
end




# Liste tous les fichiers rb d'un rpertoire et de ses sous-rpertoires,
# et l'enregistre dans un fichier nomm require.txt
#
# dir_path : chemin (relatif ou absolu) du rpertoire o commencer le listage
# rcursif. ".", "./", "" ou nil font rfrence au rpertoire courant
#
# delete : liste des fichiers  ne pas prendre en compte,  exprimer sous
# la forme "fichier.rb", "dossier/autre_fichier.rb"
#
#
# Un fichier "order.txt" peut tre plac dans un dossier. Ce fichier doit
# contenir la liste des lments devant tre chargs dans un certain ordre.
#
# Exemple :
#  dossier_module
#  ma_classe.rb
#
# Les fichiers contenus dans le dossier "dossier_module" seront chargs avant
# ma_classe.rb. Ensuite, les autres fichiers contenus dans le dossier en cours,
# puis les autres dossiers, seront chargs  leur tour.
#
# Il n'y a pas besoin de spcifier la liste de tous les fichiers et dossiers
# prsents dans le dossier pour utiliser order.txt
#
def lister_rb(dir_path="./", delete=nil, mode="w")

  dir_path = "." if dir_path == "" or dir_path.nil?

  require_txt = ""

  lister_rb_rec(dir_path, require_txt, delete)

  # Ecriture du fichier de require
  DA::file_write(F_REQUIRE, require_txt, mode)

  #p mode
  (puts F_REQUIRE ; puts require_txt ; getz) if $req_view == true

end

def lister_file(files)
  files = [files] if files.is_a?(Array) == false
  return if files.size == 0
  contenu = DA::file_read(F_REQUIRE)
  for file in files
    contenu << file+"\n"
  end
  DA::file_write(F_REQUIRE, contenu)
end


def lister_filec(files)
  files = [files] if files.is_a?(Array) == false
  for i in 0...files.size
    files[i] = File.join("./", "../../Common/lib", files[i])
  end
  lister_file(files)
end


# Fonction rcursive appele par lister_rb de require.rb
def lister_rb_rec(dir_path, require_txt, delete=nil)

  if File.directory?(dir_path) != false

    liste_dir, liste_rb = Dir::dirs_files_reg(dir_path, nil, /.*\.rb$/, false, true)
    if delete != nil
      liste_dir -= delete
      liste_rb -= delete
    end
    #p liste_dir, liste_rb
    #getz
    # On liste les fichiers ruby du dossier
    #liste_rb = Dir[File.join(dir_path, "*.rb")]
    #liste_rb -= delete

    # On liste les dossiers du rpertoire
    #liste_dir = Dir.dirs(dir_path)
    #liste_dir -= delete


    # On regarde s'il y a un fichier order.txt
    order = File.join(dir_path, "order.txt")
    if File.exist?(order) == true
      # Ouverture du fichier order
      f = File.open(order, "r")
      contenu = f.read
      f.close

      liste = contenu.split("\n");
      liste.delete("")

      for nom in liste
        nom_complet = File.join(dir_path, nom)
        # On regarde si les noms prciss existent
        if File.exist?(nom_complet)
          # On regarde si les noms prciss sont ceux de fichiers
          if File.directory?(nom_complet) == false
           # On le supprime de la liste des fichiers  traiter
           liste_rb.delete(nom_complet)
           # On l'crit dans le fichier
           add_require(require_txt, nom_complet)
          else
            # On le supprime de la liste des dossiers  traiter
            liste_dir.delete(nom_complet)
            # On relance la fonction sur le dossier prcis
            lister_rb_rec(nom_complet, require_txt, delete)
          end
        else
          # On affiche un warning
          puts(sprintf("#0 Le fichier %s est introuvable dans le dossier %s.", nom_complet, dir_path))
        end
      end


    end


    # On les crit dans le fichier
    for rb in liste_rb
      add_require(require_txt, rb)
    end

    # On traite les dossiers du rpertoire
    for nom in liste_dir
      #nom_complet = File.join(dir_path, nom)
      nom_complet = nom
      # On relance la fonction sur le dossier prcis
      lister_rb_rec(nom_complet, require_txt, delete)
    end




  end

end
private :lister_rb_rec


# Ajoute un chemin de fichiers dans la string qui sera crite
# dans require.txt
def add_require(require_txt, path)
  if path.match($require_avoid_reg)
    puts "avoid : "+path if $require_show == true
    return
  end
  require_txt << path << "\n"
end
private :add_require


# Liste les fichiers rb d'un rpertoire et de ses sous-rpertoires  partir
# d'une liste de chemins de dpart
def lister_rb_liste(liste, delete=nil)
  for path in liste
    #p path if $require_show == true
    lister_rb(path, delete, "a+")
  end
end




# Fais un require des fichiers ruby lists dans require.txt
def charger_rb(archive=false)

  puts "Load files" if $require_show == true


  # Ouverture du fichier de require
  #
  # On regarde si le fichier doit tre charg depuis l'archive
  if archive == true
    # Le fichier est lu depuis l'archive
    contenu = Archive::read(F_REQUIRE)
    #p contenu
    #Archive::write_file(F_REQUIRE)
  else
    # Le fichier est lu depuis le disque
    contenu = DA::lire_fichier(F_REQUIRE)
  end
  
  liste = contenu.split("\n")
  for rb in liste
    puts rb if $require_show == true
    require rb
  end

end

#p RUBY_VERSION
#gets

$req = [""] if $req == nil

# Pour savoir s'il s'agit du projet ou bien de l'exe
#$exerb = (Dir.pwd == "G:/PROGRAMMES/DreaMaker Netbeans/DreaMaker/lib")
#$in_dossier = (Dir.entries(Dir.pwd).include?(".svn"))
#$in_dossier = true
#p Dir.entries(Dir.pwd).sort, $in_dossier

#p $executable



# On liste et on charge tous les .rb du projet, sauf main et require
$require_avoid = [] if $require_avoid == nil
$require_avoid << "./main.rb"
$require_avoid << "./require.rb"




def lister(common=true)
  File.delete(F_REQUIRE) if File.exists?(F_REQUIRE)
  if common == true
    listerc_all
  end
  lister_rb_liste($req, $require_avoid)
end

# require pour les fichiers communs  plusieurs projets
def requirec(file)
  warn __FILE__+" requirec is deprecated"
  lib = File.join("./", "../../Common/lib", file)
  require lib
end

def require_simple
  lister
  charger_rb 
end


def require_common
  verify_require_avoid
  listerc_all
  charger_rb

  return true
end