# coding: iso-8859-1


module My_RPG

  
  class My_Event < RPG::Event

    def initialize(x, y)
      @name = ""
      @x = x
      @y = y

      @numero = -1
      @pages = [] # change
      @liste = nil

    end



    # DMK
    attr_accessor :numero
    attr_accessor :spec # hein ?
    attr_accessor :liste
    
    attr_accessor :map


    def comparer(other)
      
      #return false if @spec != event.spec
      raise(DMKW_DMK_Diff.new("my_event.numero")) if @numero != other.numero
  
  
      return super
      
    end

    def clone
      event = My_Event.new(0,0)
      for i in 0...@pages.size
        event.pages[i] = @pages[i].clone
      end
      #p event
      #gets
      return event
    end



    def to_rm03

      cont = to_128(@numero)
      #p event.liste.sort
      for element in @liste.sort
        cont << to_128(element[0]) << str_sized(element[1])
      end

      contenu = ""

      i = 0
      for page in @pages
        contenu << to_128(i+1) << page.to_rm03
        i += 1
      end

      contenu = to_128(i) << contenu

      return cont << to_128_inf(5) << str_sized(contenu) << "\000"

    end



    def to_rmxp
      event = RPG::Event.new(@x, @y)
      event.name = @name
      event.id = @numero

      for i in 0...@pages.size
        #p @pages[i]
        event.pages[i] = @pages[i].to_rmxp
      end
  
      return event
    end



    def changer_lignes!
      for i in 0...@pages.size
        #My_RPG::My_Page::changer_lignes!(@pages[i].instructions)
        @pages[i].changer_lignes!
      end
    end


    def recuperer_code_objet(codes)
      
      event_instr = nil

      for page in self.pages
        page_instr = nil
        # Pour compter le nombre total d'instructions parcourues
        #@total_instructions += page.instructions.size

        page_instr = page.recuperer_code_objet(codes)

        if page_instr != nil
          if event_instr == nil
            event_instr = Event_Instruction.new(self)
          end
          event_instr.add_page(page_instr)
        end
      end

      return event_instr
      
    end


    def total_instruction
      total = 0
      for page in self.pages
        total += page.total_instruction
      end
      return total
    end



    def recuperer_ressource
      ressources = []

      for page in self.pages
        res = page.recuperer_ressource
        next if res == nil
        ressources.concat(res)
      end

      return ressources

    end




    def exporter_dialogue
      txt = ""
      i = 0
      for i in 0...@pages.size
        txt << @pages[i].exporter_dialogue("PAGE", "Map", true)
      end

      return txt if txt == ""
      lignes = "\n"*2
      max = MAX_CARAC
      lignes << CARAC_EVENT * max + "\n"
      lignes << "EVENT #{@numero}   #{@name}   (#{@x}, #{@y})" + "\n"
      lignes << CARAC_FIN * max + "\n"
      #lignes << "\n"
      lignes << txt
      lignes << "\n"

      return lignes

      return ""
    end



    def remplacer_texte(num_page, pos, message)

      page = @pages[num_page]
      if page == nil
        message.force_encoding("UTF-8")
        raise(DMKW_Message_Replace_Pos.new("[Map:#{map.numero}:#{@numero}:#{num_page}:#{pos}]", message))
      end


      sembl = page.remplacer_texte(pos, message)

      return sembl

    end

=begin

    # Transforme un event DMK en event RMXP
    # good
    def to_rmxp_from_dmk

      event = RPG::Event.new(@x, @y)
      event.id = @numero.to_i
      event.name = @name
      event.pages = []

      for i in 0...@pages.size
        event.pages[i] = @pages[i].to_rmxp
      end
      return event
    end
=end



  end




end


