<?php


/**********************************************\
Par Marc-Antoine Kruzik
__________
Fonctions utilisées par l'application.

\**********************************************/


////////////////////////////////////////////////
// Constantes
////////////////////////////////////////////////



////////////////////////////////////////////////
// Fonctions liées à l'utilisateur
////////////////////////////////////////////////






function str_virgule($params)
{
	$txt = "";
	foreach($params as $param)
	{
		$txt .= "$param, ";
	}
	
	// On retire les deux derniers caractères (", ")
	$txt = substr($txt, 0, -2);
	return $txt;
}




////////////////////////////////////////////////
// Fonctions Serveur
////////////////////////////////////////////////


function include_once_if_exists($file_name)
{
	if (file_exists($file_name))
	{
		include_once($file_name);
	}

}

function which_server()
{
	if (file_exists("kadelfek") == true)
	{
		return "kadelfek";
	}
	else
	{
		return "local";
	}
}



////////////////////////////////////////////////
// Fonctions Temps
////////////////////////////////////////////////


function convert_hm($min)
{
	$h = intval($min/60);
	$m = $min - $h*60;
	return $h."H".sprintf("%02s", $m);
}


function convert_min($hm)
{
	preg_match('/([0-9]+)[Hh]([0-9][0-9])/', $hm, $a);
	$h = $a[1];
	$m = $a[2];
	//echoo($a);
	return $h*60+$m;
}




////////////////////////////////////////////////
// Fonctions date
////////////////////////////////////////////////


function date_fr($date) 
{ 
	$split = explode("-", $date); 
	$annee = $split[0]; 
	$mois = $split[1]; 
	$jour = $split[2]; 
	return "$jour"."/"."$mois"."/"."$annee"; 
} 


function date_us($date) 
{ 
	//echo $date;
	$split = explode("/", $date); 
	//echoo($split);
	$jour = $split[0]; 
	$mois = $split[1]; 
	$annee = $split[2]; 
	//echo $jour;
	return "$annee"."-"."$mois"."-"."$jour"; 
} 


function str_datetime()
{
	return date("Y-m-d H:i:s");
}

function str_date()
{
	return date("Y-m-d");
}



function first_day_week($date)
{
	$date_week = date("Y\WW", strtotime($date));
	$first_day_week = date("Y-m-d", strtotime($date_week));
	return $first_day_week;
	
}





////////////////////////////////////////////////
// Requêtes
////////////////////////////////////////////////


function get_connection()
{
	$connexion = new PDO('mysql:host='.PARAM_hote.';port='.PARAM_port.';dbname='.PARAM_nom_bd, PARAM_utilisateur, PARAM_mot_passe);
	return $connexion;
}




function pdo_query($pdo, $req)
{
	$res = $pdo->query($req);
	
	if ($res == null)
	{
		echo "Erreur d'execution de la requete <br />$req<br />";
	}
	return ($res);
}

function pdo_exec($pdo, $req)
{
	$res = $pdo->exec($req);
	
	if (is_integer($res) == false)
	{
		echo "Erreur d'execution de la requete <br />$req<br />";
	}
	return ($res);
}


// SELECT count(xxx) AS 'count'
function query_count($req)
{

	$obj = object_req($req);
	//echoo($obj);
	
	return $obj->count;
	
}


function req_query($req)
{
	//echo $req;
	$pdo = get_connection();
	return pdo_query($pdo, $req);
}

function req_exec($req)
{
	$pdo = get_connection();
	return pdo_exec($pdo, $req);
}



function object_req($req)
{
	$resultat = req_query($req);
	$object = $resultat->fetch(PDO::FETCH_OBJ);
	return $object;
}

function objects_req($req)
{
	$resultats = req_query($req);
	//return $resultats->fetchAll(PDO::FETCH_CLASS, 'ArrayObject');
	return $resultats->fetchAll(PDO::FETCH_OBJ);
}

function arrays_req($req)
{
	$resultats = req_query($req);
	return $resultats->fetchAll(PDO::FETCH_ASSOC);
	//return $resultats->fetchAll(PDO::FETCH_OBJ);
}




////////////////////////////////////////////////
// Affichage d'erreurs
////////////////////////////////////////////////


function echoo($obj)
{
	echo("\n");
	?> <pre> <?php print_r($obj); ?> </pre> <?php

}


function echo_error($error)
{
	echo '<div class="notification_error" id="notification_error">'.$error.'</div>';
}


function echob()
{
	?> <pre> <?php debug_print_backtrace(); ?> </pre> <?php
}


function string_req($req)
{
	$resultat = req_query($req);
	$string = $resultat->fetchColumn();
	
	return $string;
}



function last_complete_week($date)
{
	$first_day = first_day_week($date);
	$last = date("Y-m-d", strtotime("$first_day - 1 week"));
	return $last;
}





/* Enlève tous les accents d'une chaîne de caractères

*/
function remove_accents($string) 
{  

	//$title = "Trípode G5";
	$search = explode(",","ç,æ,œ,á,é,í,ó,ú,à,è,ì,ò,ù,ä,ë,ï,ö,ü,ÿ,â,ê,î,ô,û,å,e,i,ø,u");
	$replace = explode(",","c,ae,oe,a,e,i,o,u,a,e,i,o,u,a,e,i,o,u,y,a,e,i,o,u,a,e,i,o,u");
	$url = str_replace($search, $replace, $string);
	return $url;

/*
	$string = strtr($string,  
	"ÀÁÂÃÄÅàáâãäåÒÓÔÕÖØòóôõöøÈÉÊËèéêëÇçÌÍÎÏìíîïÙÚÛÜùúûüÿÑñ", 
	"aaaaaaaaaaaaooooooooooooeeeeeeeecciiiiiiiiuuuuuuuuynn");  
	
	return $string;  
*/
} ; 


// Remplace la clé des éléments du tableau par l'élément donné
function array_key_column(&$array, $key)
{
	$max = count($array);
	for($i=0; $i<$max; $i++)
	{
		$offset = $array[$i][$key];
		$array[$offset] = $array[$i];
		unset($array[$i]);
	}
}


function maj_visite($util_id)
{
	// Mise à jour de la date de visite
	$date = str_datetime();
	// Mise à jour du pseudo
	$pseudo = get_me_first_name();
	
	//echo $pseudo;
	
	$req = "UPDATE SPR_UTILISATEUR SET util_date_visite = '$date', util_nb_visite = util_nb_visite+1, util_pseudo='$pseudo' WHERE util_id = $util_id" ;
	
	$resultat = req_exec($req);


	
	
}


function date_after($date1, $date2)
{
	$comp = date_compare($date1, $date2);
	return ($comp == 1);
}

function date_before($date1, $date2)
{
	$comp = date_compare($date1, $date2);
	return ($comp == -1);
}

function date_compare($date1, $date2)
{
	//echo("$date1, $date2");

	$date1_time = strtotime($date1);
	$date2_time = strtotime($date2);

	//echo(" $date1, $date2, $date1_time, $date2_time ");
	
	//echo("$date1_time,$date2_time");
	
	if ($date1_time > $date2_time) 
	{
		return 1;
	}
	elseif ($date1_time < $date2_time) 
	{
		return -1;
	}
	else
	{
		return 0;
	}
	
}

function datetime_to_date($datetime)
{
	return date('Y-m-d', strtotime($datetime));

}


function changer_langue($lang)
{
	$GLOBALS['lang'] = $lang;
}

function date_complete($date)
{
	
	$tim = strtotime($date);
	
	$lesMois = array(0,'janvier','février','mars','avril','mai','juin','juillet', 'août', 'septembre','octobre','novembre','décembre');
	
	return date('d', $tim).' '.$lesMois[date('n', $tim)].' '.date('Y', $tim);
	
}






function get_show_ip() 
{
  if (isset($_SERVER['HTTP_X_FORWARDED_FOR'])) 
  {
    $ip = $_SERVER['HTTP_X_FORWARDED_FOR'];
  } 
  else 
  {
    $ip = $_SERVER['REMOTE_ADDR'];
  }
    return htmlspecialchars($ip);
}












?>